import * as _ionic_core from '@ionic/core';
import * as i0 from '@angular/core';
import { AfterViewInit, TemplateRef, OnInit, OnDestroy, ElementRef } from '@angular/core';
import { IStepOption, TourService, TourHotkeyListenerComponent, TourAnchorDirective, BaseTourProxyAnchor } from 'ngx-ui-tour-core';
export { Direction, StepChangeParams, StepDimensions, TourState } from 'ngx-ui-tour-core';
import { IonPopover } from '@ionic/angular/standalone';

interface IonStepOption extends IStepOption {
    placement?: IonPopoverPlacement;
    showArrow?: boolean;
    trapFocus?: boolean;
}
interface IonPopoverPlacement {
    alignment?: 'center' | 'end' | 'start';
    side?: 'bottom' | 'end' | 'left' | 'right' | 'start' | 'top';
}

declare class IonTourService<T extends IonStepOption = IonStepOption> extends TourService<T> {
    private readonly config;
    private readonly document;
    initialize(steps: T[], stepDefaults?: T): void;
    protected showStep(step: T): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<IonTourService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<IonTourService<any>>;
}

declare class TourStepTemplateComponent extends TourHotkeyListenerComponent implements AfterViewInit {
    ionPopover: IonPopover;
    stepTemplate: TemplateRef<{
        step: IonStepOption;
    }>;
    stepTemplateContent: TemplateRef<{
        step: IonStepOption;
    }>;
    step: i0.WritableSignal<IonStepOption>;
    noopLeaveAnimation: () => _ionic_core.Animation;
    protected readonly tourService: IonTourService<IonStepOption>;
    private readonly tourStepTemplateService;
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TourStepTemplateComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TourStepTemplateComponent, "tour-step-template", never, { "stepTemplate": { "alias": "stepTemplate"; "required": false; }; }, {}, ["stepTemplateContent"], never, true, never>;
}

declare class TourAnchorIonPopoverDirective implements OnInit, OnDestroy, TourAnchorDirective {
    tourAnchor: string;
    isActive: i0.WritableSignal<boolean>;
    readonly element: ElementRef<any>;
    private readonly tourService;
    private readonly stepTemplateService;
    ngOnInit(): void;
    ngOnDestroy(): void;
    showTourStep(step: IonStepOption): Promise<void>;
    hideTourStep(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TourAnchorIonPopoverDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<TourAnchorIonPopoverDirective, "[tourAnchor]", never, { "tourAnchor": { "alias": "tourAnchor"; "required": false; }; }, {}, never, never, true, never>;
}

declare class TourProxyAnchorComponent extends BaseTourProxyAnchor {
    protected readonly anchorDirective: TourAnchorIonPopoverDirective;
    anchorEl: string | HTMLElement;
    static ɵfac: i0.ɵɵFactoryDeclaration<TourProxyAnchorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TourProxyAnchorComponent, "tour-proxy-anchor", never, { "anchorEl": { "alias": "anchorEl"; "required": true; }; }, {}, never, never, true, [{ directive: typeof TourAnchorIonPopoverDirective; inputs: { "tourAnchor": "anchorId"; }; outputs: {}; }]>;
}

declare class TourIonPopoverModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<TourIonPopoverModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<TourIonPopoverModule, never, [typeof TourStepTemplateComponent, typeof TourAnchorIonPopoverDirective, typeof TourProxyAnchorComponent], [typeof TourStepTemplateComponent, typeof TourAnchorIonPopoverDirective, typeof TourProxyAnchorComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<TourIonPopoverModule>;
}

export { TourAnchorIonPopoverDirective, TourIonPopoverModule, TourProxyAnchorComponent, IonTourService as TourService, TourStepTemplateComponent };
export type { IonStepOption as IStepOption, IonPopoverPlacement };
